/*
 DSPAM
 COPYRIGHT (C) 2003 NETWORK DWEEBS CORPORATION

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "libdspam_objects.h"
#include "buffer.h"

#ifdef HAVE_CONFIG_H
#include <auto-config.h>
#endif

#ifndef _DSPAM_H
#  define _DSPAM_H

#ifndef MLOCAL
#ifdef FREEBSD
#       define  MLOCAL          "/usr/libexec/mail.local"
#endif

#ifdef LINUX
#       define  MLOCAL          "/usr/bin/procmail"
#endif

#ifdef SOLARIS2
#       define  MLOCAL          "/usr/bin/mail"
#endif
#endif

/* Signature identifiers; don't modify unless you understand the 
   subtle consequences */

#define         SIGNATURE_BEGIN		"!DSPAM:"
#define         SIGNATURE_END		"!"
#define         LOOSE_SIGNATURE_BEGIN	"DSPAM:"
#define         SIGNATURE_DELIMITER	":"

/* Public agent functions */
int deliver_message(const char *message, const char *mailer_args, const char *username, int mode);
int process_message(buffer *message, const char *username, int mode, int corpus);
int write_web_stats(const char *username, struct _ds_spam_totals *totals);
int quarantine_message(const char *message, const char *username);
int quarantine_unlock(const char *username);
int quarantine_lock(const char *username);

/* DO NOT MODIFY BELOW THIS LINE */

#define MAX(a,b)  ((a)>(b)?(a):(b))
#define MIN(a,b)  ((a)<(b)?(a):(b))

#endif /* _DSPAM_H */

