create table dspam_token_data (
  uid smallint unsigned,
  token bigint unsigned,
  spam_hits int,
  innocent_hits int,
  last_hit date
) type=InnoDB;

create unique index id_token_data_01 on dspam_token_data(uid,token);

create table dspam_signature_data (
  uid smallint unsigned,
  signature varchar(128),
  data blob,
  length smallint,
  created_on date
) type=InnoDB;

create unique index id_signature_data_01 on dspam_signature_data(uid,signature);

create table dspam_stats (
  uid smallint unsigned primary key,
  total_spam int,
  total_innocent int,
  spam_misses int,
  false_positives int
) type=InnoDB;

