/*
 DSPAM
 COPYRIGHT (C) 2003 NETWORK DWEEBS CORPORATION

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifdef HAVE_CONFIG_H
#include <auto-config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <ctype.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifdef TIME_WITH_SYS_TIME
#   include <sys/time.h>
#   include <time.h>
#else
#   ifdef HAVE_SYS_TIME_H
#       include <sys/time.h>
#   else
#       include <time.h>
#   endif
#endif

#include "../libdspam.h"
#include "../storage_driver.h"
#include "../config.h"
#include "../language.h"
#include "../util.h"
#include "../error.h"

/* headers */
int dump_database(DSPAM_CTX *CTX);

#define TSYNTAX	"syntax: dspam_dump [username]"

int main(int argc, char **argv) {
  DSPAM_CTX *CTX;
  int r;

  if (argc<2) {
    fprintf(stderr, "%s\n", TSYNTAX);
    exit(EXIT_FAILURE);
  }

  CTX = dspam_init(argv[1], NULL, DSM_TOOLS, DSF_CLASSIFY);
  if (CTX == NULL) {
    fprintf(stderr, "Could not init context: %s\n", strerror(errno));
    exit(EXIT_FAILURE);
  }

  r = dump_database(CTX);

  return (r) ? EXIT_FAILURE : EXIT_SUCCESS;
}

int dump_database(DSPAM_CTX *CTX) {
  struct _ds_storage_record *sr;

  printf("TOTALS: TS: %ld TI: %ld TM: %ld FP: %ld\n", CTX->totals.total_spam, CTX->totals.total_innocent, CTX->totals.spam_misses, CTX->totals.false_positives);

  sr = _ds_get_nexttoken(CTX);
  while(sr != NULL) {
    printf("%-32llu S: %05ld  I: %05ld  LH: %s", sr->token, sr->spam_hits, sr->innocent_hits, ctime(&sr->last_hit));
    free(sr);
    sr = _ds_get_nexttoken(CTX);
  }

  return 0;
}
